/*
 * file:                  Computer.cpp
 * description:           Example of C++ class implementation.
 * author:                Julien Tierny <tierny@telecom-paristech.fr>.
 * date:                  July 2014.
 */

#include                  <Computer.h>

Computer::Computer(){
  
  // set default values
  memory_ = 7.8;
  cpuFrequency_ = 2.67;
  hardDiskCapacity_ = 500;
  
  turnedOn_ = false;
}

Computer::~Computer(){
  
  cout << "Definitely shut down. Good bye!" << endl;
}

int Computer::readAsciiConfiguration(string &fileName){

  ifstream file(fileName.data(), ios::in);
  
  file >> memory_;
  
  file >> cpuFrequency_;
  
  file >> hardDiskCapacity_;
  
  file.close();
  
  return 0;
}

int Computer::readBinaryConfiguration(string &fileName){

  ifstream file(fileName.data(), ios::in | ios::binary);
  
  file.read((char *) &memory_, sizeof(double));
  file.read((char *) &cpuFrequency_, sizeof(double));
  file.read((char *) &hardDiskCapacity_, sizeof(double));
  
  file.close();
  
  return 0;
}


int Computer::turnOn(){
  
  turnedOn_ = true;
  
  cout << "The computer has booted (CPU: " 
    << cpuFrequency_ << " GHz, RAM: " 
    << memory_ << " Go, HDD: " 
    << hardDiskCapacity_ << " Go)" << endl;
  
  return 0;
}

int Computer::turnOff(){
  
  turnedOn_ = false;
  cout << "Turning off the computer..." << endl;
  
  return 0;
}

int Computer::writeAsciiConfiguration(string &fileName){
  
  ofstream file(fileName.data(), ios::out);
  
  file << memory_;
  file << endl;
  
  file << cpuFrequency_;
  file << endl;
  
  file << hardDiskCapacity_;
  file << endl;
  
  file.close();
  
  return 0;
}

int Computer::writeBinaryConfiguration(string &fileName){
  
  ofstream file(fileName.data(), ios::out | ios::binary);
  
  file.write((char *) &memory_, sizeof(double));
  file.write((char *) &cpuFrequency_, sizeof(double));
  file.write((char *) &hardDiskCapacity_, sizeof(double));
  
  file.close();
  
  return 0;
}
