/*
 * file:                  Computer.h
 * description:           Example of C++ class specification.
 * author:                Julien Tierny <tierny@telecom-paristech.fr>.
 * date:                  July 2014.
 */

#pragma once
#include                  <iostream>
#include                  <fstream>

using namespace std;

class Computer{
  
  public:
    
    // constructor
    Computer();
    
    // destructor
    ~Computer();
   
    int readAsciiConfiguration(string &fileName);
    
    int readBinaryConfiguration(string &fileName);
    
    virtual int turnOn();
    
    int turnOff();
    
    int writeAsciiConfiguration(string &fileName);
    
    int writeBinaryConfiguration(string &fileName);
    
    
  protected:
   
    double                memory_, cpuFrequency_, hardDiskCapacity_;
    
  private:
    
    bool                  turnedOn_;
    
};